#!/bin/bash

if [ -x '/usr/bp/bin/bputil' ]
then
	export NDMP_USER=$(/usr/bp/bin/bputil -g -c localhost NDMP Username ndmp /usr/bp/bpinit/master.ini)
	export NDMP_PASS=$(/usr/bp/bin/bputil -g -c localhost NDMP Password unitrendsndmp /usr/bp/bpinit/master.ini)
else
	export NDMP_USER=ndmp
	export NDMP_PASS=unitrendsndmp
fi

# Add -d to expect for debug output
expect << EOF
	log_user 0
	set timeout 60
	spawn /usr/bp/bin/ndmp/ndmpadm enable -a cram-md5 -u $::env(NDMP_USER)
	expect -re "Enter new password:"
	send "$::env(NDMP_PASS)\n"
	expect -re "Re-enter  password:"
	send "$::env(NDMP_PASS)\n"
	expect eof
EOF

unset NDMP_USER
unset NDMP_PASS

# The value in master.ini takes precedence. If no value is found, try seth0 and eth0.
IPADDR_NDMP=$(/usr/bp/bin/bputil -g -c localhost NDMP IPv4Address "" /usr/bp/bpinit/master.ini)
if [ -z ${IPADDR_NDMP} ]
then
	# Hyper-V on Centos 5 renames the ethernet device to seth0, so use that if appropriate.
	# Centos 6 builds do not do this and use eth0.
	# FUTURE: Centos 7 doesn't use eth0 so this will probably need updating at that time.
	#         A workaround at that time is to use the master.ini entry.

	if ifconfig | grep -q "seth0"
	then
		IPADDR_NDMP=$(ifconfig seth0 | grep 'inet addr:' | cut -d: -f2 | awk '{ print $1}')
	elif ifconfig | grep -q "eth0"
	then
		IPADDR_NDMP=$(ifconfig eth0 | grep 'inet addr:' | cut -d: -f2 | awk '{ print $1}')
	else
		IPADDR_NDMP=""
	fi

fi

/usr/bp/bin/ndmp/ndmpadm set -p mover-nic=$IPADDR_NDMP

# sed cannot be safely used to perform a substitution with a variable because
# the variable is interpreted by the shell, not sed.
cp /usr/bp/bin/ndmp/ndmpd.conf /usr/bp/bin/ndmp/ndmpd.conf.old
awk -v IPADDR_NDMP="${IPADDR_NDMP}" '{
	sub(/mover-nic.*/, "mover-nic = \"" IPADDR_NDMP "\"");
	print;
}' /usr/bp/bin/ndmp/ndmpd.conf.old > /usr/bp/bin/ndmp/ndmpd.conf
